﻿@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization

@inject PuestosAgent puestosAgent
@inject DepartamentoAgent departamentoAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnUpdate=@UpdateItem OnDelete=@DeleteItem OnCreate=@CreateItem>
    <GridToolBar>
        <GridCommandButton Command="Add" Icon="add">Agregar Puesto</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(PuestoDto.Nombre) Editable="true" />
        <GridColumn Field=@nameof(PuestoDto.CreadoPor) Editable="false" Title="Creado Por" />
        <GridColumn Field=@nameof(PuestoDto.DepartamentoId) Editable="true" Title="Departamento">
            <Template>
                @{
                    int departamentoId = (context as PuestoDto).DepartamentoId;
                    <text>@departamentos.Where(b => b.Id == departamentoId).FirstOrDefault().Nombre</text>
                }
            </Template>
            <EditorTemplate>
                @{
                    PuestoDto puesto = context as PuestoDto;
                } 
                <div class="k-form-field">
                    <div class="k-form-field-wrap">
                        <TelerikComboBox Data="@departamentos" Placeholder="Selecciona el Departamento" @bind-Value="@puesto.DepartamentoId"
                                         TextField="@nameof(DepartamentoDto.Nombre)" ValueField="@nameof(DepartamentoDto.Id)" Filterable="true"Width="100%">
                        </TelerikComboBox>
                    </div>
                </div>
            </EditorTemplate>
        </GridColumn>
        <GridColumn Field=@nameof(PuestoDto.FechaRegistro) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Registro" />
        <GridColumn Field=@nameof(PuestoDto.ModificadoPor) Editable="false" Title="Modificado Por" />
        <GridColumn Field=@nameof(PuestoDto.FechaModificacion) Editable="false" DisplayFormat="{0:dd/MM/yyyy hh:mm tt}" Title="Fecha de Modificación" />
        <GridCommandColumn Width="120px">
            <GridCommandButton Command="Edit" Icon="edit"></GridCommandButton>
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    public List<PuestoDto> GridData { get; set; } = new List<PuestoDto>();

    public List<DepartamentoDto> departamentos { get; set; } = new List<DepartamentoDto>();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        try
        {
            GridData = await puestosAgent.Get();
            departamentos = await departamentoAgent.Get();
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void CreateItem(GridCommandEventArgs args)
    {
        try
        {
            PuestoDto puesto = args.Item as PuestoDto;
            puesto.Borrado = false;
            puesto.CreadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            puesto.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await puestosAgent.Add(puesto);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        PuestoDto puesto = args.Item as PuestoDto;
        try
        {
            if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
            {

            }
            await puestosAgent.Remove(puesto.Id);
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }
        StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        try
        {
            PuestoDto puesto = args.Item as PuestoDto;
            puesto.ModificadoPor = authenticationState.Result.User.Claims.Where(b => b.Type == "Id").FirstOrDefault().Value;
            await puestosAgent.Edit(puesto);
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }
}